int pwm_a = 3;               // Left motor
int dir_a = 12;

int pwm_b = 11;              // Right motor
int dir_b = 13;

void setup() {
  setupDrive();
  Serial.begin(9600);
}

void loop() {
  drive_fwd();              // Drive forward, delay 2 seconds
    delay(2000);
  drive_turnR();
    delay(2000);
  drive_turnL();
    delay(2000);
  drive_rev();
    delay(2000);
}

void setupDrive() {
  pinMode(pwm_a, OUTPUT);   //Set control pins to be outputs
  pinMode(pwm_b, OUTPUT);
  pinMode(dir_a, OUTPUT);
  pinMode(dir_b, OUTPUT);
}

void drive_fwd() {
  digitalWrite(dir_a, LOW);
  digitalWrite(dir_b, LOW);
  analogWrite(pwm_a, 100);  // Full speed (100%)
  analogWrite(pwm_b, 100);
}

void drive_turnR() {
  digitalWrite(dir_a, LOW);
  digitalWrite(dir_b, HIGH);
  setPWM(pwm_a, 70);        //Set speed to 70%
  setPWM(pwm_b, 70);
}

void drive_turnL() {
  digitalWrite(dir_a, HIGH);
  digitalWrite(dir_b, LOW);
  setPWM(pwm_a, 85);        //Set speed to 85%
  setPWM(pwm_b, 85);
}

void drive_rev() {
  digitalWrite(dir_a, HIGH);
  digitalWrite(dir_b, HIGH);
  analogWrite(pwm_a, 100); 
  analogWrite(pwm_b, 100);
}

// Set PWM speed using percentages, 
//  map to 0 to 255 (255=fastest)
void setPWM(int pin, int val) {
  analogWrite(pin, map(val, 0, 100, 0, 255));
}

